sampler  tex0   : register(s0);
float4   cnt    : register(c0);

//܂Ȃ
float4   vParam : register(c3);
float4x4 mWVP   : register(c16);
float4x4 mV     : register(c20);
float4   vEye   : register(c23);
float4x4 mP     : register(c24);
float4x4 mRot   : register(c28);
float    PI = 3.141592653;

struct VS_OUTPUT {
  float4 pos : POSITION;
  float4 tex : TEXCOORD0;
};

//̂܂psɓn
VS_OUTPUT vs_main(VS_OUTPUT input) {
  VS_OUTPUT ret = (VS_OUTPUT)0;
  ret.pos = input.pos;
  ret.tex = input.tex;
  return ret;
}


float inter_sphere(float3 ro, float3 rd, float3 sphere, float r) {
  float3 d = ro - sphere;
  float  b = dot(rd, d);
  float  c = dot(d, d) - r * r;
  float  t = b * b - c;
  if(t > 0) {
    t = -b - sqrt(t);
    return t;
  }
  
  return 0;
}

float four_sphere(float3 ro, float3 rd, float3 offset) {
  float3 sphere1 = float3(0 - 0.5f, 0 - 0.5f, 0) + offset;
  float3 sphere2 = float3(0 - 0.5f, 0 + 0.5f, 0) + offset;
  float3 sphere3 = float3(0 + 0.5f, 0 - 0.5f, 0) + offset;
  float3 sphere4 = float3(0 + 0.5f, 0 + 0.5f, 0) + offset;
  float t;
  float r = 0.15f;
  t = inter_sphere(ro, rd, sphere1, r);
  if(t > 0) return t;
  
  t = inter_sphere(ro, rd, sphere2, r);
  if(t > 0) return t;
  
  t = inter_sphere(ro, rd, sphere3, r);
  if(t > 0) return t;
  
  t = inter_sphere(ro, rd, sphere4, r);
  if(t > 0) return t;
  
  return 0;
}


float4 ps_main(float2 p:texcoord) : color {
  float ct = cnt.x;
  float3 ro = float3(cos(ct * 0.5) * 0.2f, cos(ct * 0.5) * 0.3f, -2);
  float3 eye = ro;
  float3 dir = normalize(float3(p.x, p.y, 0) - eye);
  ro.x = sin(ct * 0.5);
  ro.y = (ro.y + ct * 0.7) % 1;
  ro.z = (ro.z + ct * 0.8) % 1;
  for(int i = 0 ; i < 20; i++) {
    float3 offset = (dir * i);
    eye = (ro + offset) % 1;
    float t = four_sphere(eye, dir, offset);
    if(t > 0) {
      float diff = 1;
      return float4(diff * 0.97, diff, diff, 1) - exp(-t * 0.20f);
    }
  }
  return 1;
}

//Ȃ
technique shader {
  pass {
    VertexShader = compile ps_3_0 vs_main();
    PixelShader  = compile ps_3_0 ps_main();
  }
}


